/[gentoo-x86]/x11-base/xorg-server/xorg-server-1.7.6.ebuild
Gentoo

Contents of /x11-base/xorg-server/xorg-server-1.7.6.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.11 - (show annotations) (download)
Sun Sep 5 11:59:11 2010 UTC (4 years, 6 months ago) by remi
Branch: MAIN
Changes since 1.10: +4 -2 lines
x11-base/xorg-server: add missing libXv dep, fixes bug #335025

(Portage version: 2.2_rc69/cvs/Linux i686)

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/x11-base/xorg-server/xorg-server-1.7.6.ebuild,v 1.10 2010/08/02 18:37:23 armin76 Exp $
4
5 EAPI="2"
6
7 # Must be before x-modular eclass is inherited
8 SNAPSHOT="yes"
9
10 inherit x-modular multilib versionator
11
12 EGIT_REPO_URI="git://anongit.freedesktop.org/git/xorg/xserver"
13
14 OPENGL_DIR="xorg-x11"
15
16 DESCRIPTION="X.Org X servers"
17 KEYWORDS="alpha amd64 arm hppa ia64 ~mips ppc ppc64 sh sparc x86 ~x86-fbsd"
18
19 IUSE_SERVERS="dmx kdrive xorg"
20 IUSE="${IUSE_SERVERS} tslib hal ipv6 minimal nptl sdl"
21 RDEPEND="hal? ( sys-apps/hal )
22 tslib? ( >=x11-libs/tslib-1.0 x11-proto/xcalibrateproto )
23 dev-libs/openssl
24 >=x11-libs/libXfont-1.3.3
25 >=x11-libs/xtrans-1.2.2
26 >=x11-libs/libXau-1.0.4
27 >=x11-libs/libxkbfile-1.0.4
28 >=x11-libs/libXdmcp-1.0.2
29 >=x11-libs/libpciaccess-0.10.3
30 >=x11-libs/pixman-0.15.20
31 media-libs/freetype
32 >=x11-misc/xbitmaps-1.0.1
33 >=x11-misc/xkeyboard-config-1.4
34 x11-apps/xkbcomp
35 >=x11-apps/iceauth-1.0.2
36 >=x11-apps/rgb-1.0.3
37 >=x11-apps/xauth-1.0.3
38 <=x11-apps/xinit-1.2.1
39 >=app-admin/eselect-opengl-1.0.8
40 dmx? (
41 x11-libs/libXt
42 >=x11-libs/libdmx-1.0.99.1
43 >=x11-libs/libX11-1.1.5
44 >=x11-libs/libXaw-1.0.4
45 >=x11-libs/libXext-1.0.5
46 >=x11-libs/libXfixes-4.0.3
47 >=x11-libs/libXi-1.2.99.1
48 >=x11-libs/libXmu-1.0.3
49 >=x11-libs/libXtst-1.0.3
50 )
51 !minimal? (
52 >=x11-libs/libX11-1.1.5
53 >=x11-libs/libXext-1.0.5
54 >=x11-libs/libXres-1.0.3
55 >=media-libs/mesa-7.4[nptl=]
56 )
57 >=x11-libs/libxkbui-1.0.2
58 kdrive? (
59 >=x11-libs/libXext-1.0.5
60 x11-libs/libXv
61 sdl? ( media-libs/libsdl )
62 )"
63 # Xres is dmx-dependent
64 # Xaw is dmx-dependent
65 # Xpm is dmx-dependent, pulls in Xt
66 # xkbcomp is launched at startup but not checked by ./configure
67
68 ## Deps that don't have a version in configure.ac but do here:
69 # x11-proto/resourceproto
70 # x11-proto/fontsproto
71 # x11-libs/libXau
72 # x11-libs/libXfont
73 # x11-libs/libXdmcp
74 # x11-libs/libXext
75 # x11-libs/libX11
76 # x11-libs/libXrender
77 # x11-libs/libXmu
78 # x11-libs/libXfixes
79 # x11-libs/libXtst
80 # x11-proto/xineramaproto
81 # x11-proto/dmxproto
82 ## Deps that are larger here than in configure.ac
83 # x11-libs/libpciaccess-0.8.0
84 #
85
86 DEPEND="${RDEPEND}
87 !!net-dialup/dtrace
88 sys-devel/flex
89 >=x11-proto/randrproto-1.2.99.3
90 >=x11-proto/renderproto-0.11
91 >=x11-proto/fixesproto-4.1
92 >=x11-proto/damageproto-1.1
93 >=x11-proto/xextproto-7.0.99.3
94 >=x11-proto/xproto-7.0.13
95 >=x11-proto/xf86dgaproto-2.0.99.1
96 >=x11-proto/xf86rushproto-1.1.2
97 >=x11-proto/xf86vidmodeproto-2.2.99.1
98 >=x11-proto/compositeproto-0.4
99 >=x11-proto/recordproto-1.13.99.1
100 >=x11-proto/resourceproto-1.0.2
101 >=x11-proto/videoproto-2.2.2
102 >=x11-proto/scrnsaverproto-1.1
103 >=x11-proto/trapproto-3.4.3
104 >=x11-proto/xineramaproto-1.1.3
105 >=x11-proto/fontsproto-2.0.2
106 >=x11-proto/kbproto-1.0.3
107 >=x11-proto/inputproto-1.9.99.902
108 >=x11-proto/bigreqsproto-1.1.0
109 >=x11-proto/xcmiscproto-1.2.0
110 >=x11-proto/glproto-1.4.9
111 dmx? ( >=x11-proto/dmxproto-2.2.99.1 )
112 !minimal? (
113 >=x11-proto/xf86driproto-2.1.0
114 >=x11-proto/dri2proto-2.1
115 >=x11-libs/libdrm-2.3.0
116 )"
117
118 PDEPEND="xorg? ( >=x11-base/xorg-drivers-$(get_version_component_range 1-2) )"
119
120 EPATCH_FORCE="yes"
121 EPATCH_SUFFIX="patch"
122
123 # These have been sent upstream
124 UPSTREAMED_PATCHES=(
125 #"${WORKDIR}/patches/"
126
127 # Fix from bug http://bugs.freedesktop.org/show_bug.cgi?id=25400
128 "${FILESDIR}/1.7.3.901-0001-dix-if-owner-events-is-true-for-passive-grabs-add-th.patch"
129 # Fix for bug #304067
130 "${FILESDIR}/1.7.5.902-fix-tslib-1.0-check.patch"
131 )
132
133 PATCHES=(
134 "${UPSTREAMED_PATCHES[@]}"
135 )
136
137 pkg_setup() {
138 use minimal || ensure_a_server_is_building
139
140 # SDL only available in kdrive build
141 if use kdrive && use sdl; then
142 conf_opts="${conf_opts} --enable-xsdl"
143 else
144 conf_opts="${conf_opts} --disable-xsdl"
145 fi
146
147 # localstatedir is used for the log location; we need to override the default
148 # from ebuild.sh
149 # sysconfdir is used for the xorg.conf location; same applies
150 # --enable-install-setuid needed because sparcs default off
151 CONFIGURE_OPTIONS="
152 $(use_enable ipv6)
153 $(use_enable dmx)
154 $(use_enable kdrive)
155 $(use_enable tslib)
156 $(use_enable tslib xcalibrate)
157 $(use_enable !minimal xvfb)
158 $(use_enable !minimal xnest)
159 $(use_enable !minimal record)
160 $(use_enable !minimal xfree86-utils)
161 $(use_enable !minimal install-libxf86config)
162 $(use_enable !minimal dri)
163 $(use_enable !minimal dri2)
164 $(use_enable !minimal glx)
165 $(use_enable xorg)
166 $(use_enable nptl glx-tls)
167 $(use_enable hal config-hal)
168 --sysconfdir=/etc/X11
169 --localstatedir=/var
170 --enable-install-setuid
171 --with-fontdir=/usr/share/fonts
172 --with-xkb-output=/var/lib/xkb
173 --without-dtrace
174 ${conf_opts}"
175
176 # (#121394) Causes window corruption
177 filter-flags -fweb
178
179 # Incompatible with GCC 3.x SSP on x86, bug #244352
180 if use x86 ; then
181 if [[ $(gcc-major-version) -lt 4 ]]; then
182 filter-flags -fstack-protector
183 fi
184 fi
185
186 # Incompatible with GCC 3.x CPP, bug #314615
187 if [[ $(gcc-major-version) -lt 4 ]]; then
188 ewarn "GCC 3.x C preprocessor may cause build failures. Use GCC 4.x"
189 ewarn "or set CPP=cpp-4.3.4 (replace with the actual installed version)"
190 fi
191
192 OLD_IMPLEM="$(eselect opengl show)"
193 eselect opengl set ${OPENGL_DIR}
194 }
195
196 src_install() {
197 x-modular_src_install
198
199 dynamic_libgl_install
200
201 server_based_install
202
203 if ! use minimal && use xorg; then
204 # Install xorg.conf.example (see bugs #151421 and #151670)
205 insinto /etc/X11
206 doins hw/xfree86/xorg.conf.example \
207 || die "couldn't install xorg.conf.example"
208 fi
209 }
210
211 pkg_postinst() {
212 switch_opengl_implem
213
214 echo
215 ewarn "You must rebuild all drivers if upgrading from xorg-server 1.6"
216 ewarn "or earlier, because the ABI changed. If you cannot start X because"
217 ewarn "of module version mismatch errors, this is your problem."
218
219 echo
220 ewarn "You can generate a list of all installed packages in the x11-drivers"
221 ewarn "category using this command:"
222 ewarn "emerge portage-utils; qlist -I -C x11-drivers/"
223
224 ebeep 5
225 epause 10
226 }
227
228 pkg_postrm() {
229 # Get rid of module dir to ensure opengl-update works properly
230 if ! has_version x11-base/xorg-server; then
231 if [[ -e ${ROOT}/usr/$(get_libdir)/xorg/modules ]]; then
232 rm -rf "${ROOT}"/usr/$(get_libdir)/xorg/modules
233 fi
234 fi
235 }
236
237 dynamic_libgl_install() {
238 # next section is to setup the dynamic libGL stuff
239 ebegin "Moving GL files for dynamic switching"
240 dodir /usr/$(get_libdir)/opengl/${OPENGL_DIR}/extensions
241 local x=""
242 for x in "${D}"/usr/$(get_libdir)/xorg/modules/extensions/lib{glx,dri,dri2}*; do
243 if [ -f ${x} -o -L ${x} ]; then
244 mv -f ${x} "${D}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/extensions
245 fi
246 done
247 eend 0
248 }
249
250 server_based_install() {
251 if ! use xorg; then
252 rm "${D}"/usr/share/man/man1/Xserver.1x \
253 "${D}"/usr/$(get_libdir)/xserver/SecurityPolicy \
254 "${D}"/usr/$(get_libdir)/pkgconfig/xorg-server.pc \
255 "${D}"/usr/share/man/man1/Xserver.1x
256 fi
257 }
258
259 switch_opengl_implem() {
260 # Switch to the xorg implementation.
261 # Use new opengl-update that will not reset user selected
262 # OpenGL interface ...
263 echo
264 eselect opengl set ${OLD_IMPLEM}
265 }
266
267 ensure_a_server_is_building() {
268 for server in ${IUSE_SERVERS}; do
269 use ${server} && return;
270 done
271 eerror "You need to specify at least one server to build."
272 eerror "Valid servers are: ${IUSE_SERVERS}."
273 die "No servers were specified to build."
274 }

  ViewVC Help
Powered by ViewVC 1.1.20